/************************************************************
Ismael Bamba ismael.bamba@laposte.net
*************************************************************/

#ifndef _ENETCOMMON_H_
#define _ENETCOMMON_H_

#define  interface struct
#define _ENET_CALLING_CONVENTION_ __stdcall

static const char* ENET_FACTORY_NAME  = "GetEnetInstance";
#if defined(_DEBUG)
static const char* ENETLIBRARYNAME    = "libEnet_d.dll";
#else
static const char* ENETLIBRARYNAME    = "libEnet.dll";
#endif
//Class Factory for Run-Time Dynamic Linking
typedef   int(_ENET_CALLING_CONVENTION_ *ENETFACTORY)(void**);
//Class Factory for Run-Time Dynamic Linking
static int _ENET_CALLING_CONVENTION_ GetEnetFactoryEntryPoint(HMODULE* hDll,void** ppInt)
{
     int ret=-1;
     *hDll=LoadLibraryEx(ENETLIBRARYNAME,NULL,NULL);
     if(*hDll)
	 {
		ENETFACTORY pGetEnetInstance= (ENETFACTORY)GetProcAddress(*hDll,ENET_FACTORY_NAME);
                if(pGetEnetInstance)
		{
			ret=(*pGetEnetInstance)(ppInt);
		}
	 }
	 return ret;
}


#endif //_ENETCOMMON_H_
