/************************************************************
DllMain - library entry point
Enet windows library
August 25,2004
Ismael Bamba / ismael.bamba@laposte.net
*************************************************************/

#include <windows.h>

// DllMain() is the entry-point function for this DLL. 
BOOL APIENTRY DllMain(HINSTANCE hinstDLL,  // DLL module handle
    DWORD fdwReason,              // reason called
    LPVOID lpvReserved)           // reserved
{ 
	UNREFERENCED_PARAMETER(lpvReserved);
	switch (fdwReason) 
    { 
        // The DLL is loading due to process 
        // initialization or a call to LoadLibrary. 
        case DLL_PROCESS_ATTACH:
			DisableThreadLibraryCalls(hinstDLL);
			break;

        // The attached process creates a new thread. 
        case DLL_THREAD_ATTACH:
            break; 
 
        // The thread of the attached process terminates.
        case DLL_THREAD_DETACH: 
			break; 
 
        // DLL unload due to process termination or FreeLibrary. 
        case DLL_PROCESS_DETACH:
            break; 
 
        default: 
            break; 
    } 
 
    return TRUE; 
    UNREFERENCED_PARAMETER(hinstDLL); 
    UNREFERENCED_PARAMETER(lpvReserved); 
}
