// libEnet.cpp : Defines the entry point for the application.
//
#include <libEnet.h>


//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Initialize (void)
{
	return enet_initialize(); 
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Deinitialize (void)
{
	enet_deinitialize(); 
}
//-------------------------------------------------------------------------------------
enet_uint32 _ENET_CALLING_CONVENTION_ CEnet::Time_get (void)
{
	 return enet_time_get(); 
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Time_set (enet_uint32 u)
{
	enet_time_set(u); 
}
//-------------------------------------------------------------------------------------
ENetSocket _ENET_CALLING_CONVENTION_ CEnet::Socket_create (ENetSocketType t, const ENetAddress * c)
{
	return enet_socket_create (t, c);
}
//-------------------------------------------------------------------------------------
ENetSocket _ENET_CALLING_CONVENTION_ CEnet::Socket_accept (ENetSocket s, ENetAddress * c)
{
	return enet_socket_accept (s, c);
}
//-------------------------------------------------------------------------------------
int  _ENET_CALLING_CONVENTION_ CEnet::Socket_connect (ENetSocket t, const ENetAddress *c)
{
	return enet_socket_connect (t, c);
}
//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Socket_send (ENetSocket e, const ENetAddress *c, const ENetBuffer *cc, size_t t)
{
	return enet_socket_send (e, c, cc,t);
}
//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Socket_receive (ENetSocket e, ENetAddress *ee, ENetBuffer *eee, size_t t)
{
	return enet_socket_receive (e, ee, eee,t);
}
//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Socket_wait (ENetSocket e, enet_uint32 *p, enet_uint32 t)
{
	return enet_socket_wait (e, p, t);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Socket_destroy (ENetSocket e)
{
	enet_socket_destroy (e);
}
//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Address_set_host (ENetAddress *address, const char *hostName )
{
	return enet_address_set_host (address, hostName );
}
//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Address_get_host (const ENetAddress *address, char *hostName, size_t nameLength )
{
	return enet_address_get_host (address,hostName,nameLength );
}
//-------------------------------------------------------------------------------------
ENetPacket * _ENET_CALLING_CONVENTION_ CEnet::Packet_create (const void *dataContents, size_t dataLength, enet_uint32 flags)
{
	return enet_packet_create (dataContents,dataLength, flags);
}
//-------------------------------------------------------------------------------------
void    _ENET_CALLING_CONVENTION_  CEnet::Packet_destroy (ENetPacket *packet )
{
 enet_packet_destroy (packet );
}
//-------------------------------------------------------------------------------------
int     _ENET_CALLING_CONVENTION_  CEnet::Packet_resize  (ENetPacket *packet, size_t dataLength )
{
	return enet_packet_resize  (packet,dataLength );
}
//-------------------------------------------------------------------------------------
ENetHost * _ENET_CALLING_CONVENTION_ CEnet::Host_create (const ENetAddress *address, size_t peerCount, enet_uint32 incomingBandwidth, enet_uint32 outgoingBandwidth )
{
	return enet_host_create (address,peerCount,incomingBandwidth,outgoingBandwidth );
}
//-------------------------------------------------------------------------------------
void       _ENET_CALLING_CONVENTION_ CEnet::Host_destroy (ENetHost *host )
{
	enet_host_destroy (host );
}
//-------------------------------------------------------------------------------------
ENetPeer * _ENET_CALLING_CONVENTION_ CEnet::Host_connect (ENetHost *host, const ENetAddress *address, size_t channelCount )
{
	 return enet_host_connect (host,address,channelCount ); 
}
//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Host_service (ENetHost * e, ENetEvent * ee, enet_uint32 flags)
{
	 return enet_host_service (e, ee, flags);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Host_flush (ENetHost *e)
{
  enet_host_flush (e);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Host_broadcast (ENetHost *e, enet_uint8 flags, ENetPacket *p)
{
	enet_host_broadcast (e, flags, p);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Host_bandwidth_limit (ENetHost *e, enet_uint32 flags1, enet_uint32 flags2)
{
	enet_host_bandwidth_limit (e,flags1, flags2);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Host_bandwidth_throttle (ENetHost *e)
{
	enet_host_bandwidth_throttle (e);
}
//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Peer_send (ENetPeer *e, enet_uint8 flags, ENetPacket *p)
{
	return enet_peer_send (e,flags,p);
}
//-------------------------------------------------------------------------------------
ENetPacket* _ENET_CALLING_CONVENTION_ CEnet::Peer_receive (ENetPeer *e, enet_uint8 flag)
{
	return enet_peer_receive (e,flag);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Peer_ping (ENetPeer *h)
{
	 enet_peer_ping (h);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Peer_reset (ENetPeer *)
{
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Peer_disconnect (ENetPeer *h)
{
	enet_peer_disconnect (h);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Peer_disconnect_now (ENetPeer *h)
{
	 enet_peer_disconnect_now (h);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Peer_throttle_configure (ENetPeer *p, enet_uint32 f1, enet_uint32 f2, enet_uint32 f3)
{
	enet_peer_throttle_configure (p,f1, f2,f3);
}
//-------------------------------------------------------------------------------------
int _ENET_CALLING_CONVENTION_ CEnet::Peer_throttle (ENetPeer *p, enet_uint32 flag)
{
	return enet_peer_throttle (p,flag);
}
//-------------------------------------------------------------------------------------
void _ENET_CALLING_CONVENTION_ CEnet::Peer_reset_queues (ENetPeer *p)
{
	enet_peer_reset_queues (p);
}
//-------------------------------------------------------------------------------------
ENetOutgoingCommand * _ENET_CALLING_CONVENTION_ CEnet::Peer_queue_outgoing_command (ENetPeer *peer, const ENetProtocol *proto, ENetPacket *pkt, enet_uint32 flag1, enet_uint16 flag2)
{
	return enet_peer_queue_outgoing_command (peer, proto, pkt,flag1,flag2);
}
//-------------------------------------------------------------------------------------
ENetIncomingCommand * _ENET_CALLING_CONVENTION_ CEnet::Peer_queue_incoming_command (ENetPeer *peer, const ENetProtocol *proto, ENetPacket *pkt, enet_uint32 flag)
{
	return enet_peer_queue_incoming_command (peer,proto, pkt,flag);
}
//-------------------------------------------------------------------------------------
ENetAcknowledgement * _ENET_CALLING_CONVENTION_ CEnet::Peer_queue_acknowledgement (ENetPeer *peer, const ENetProtocol *proto, enet_uint32 flag)
{
	return enet_peer_queue_acknowledgement (peer,proto,flag);
}
//-------------------------------------------------------------------------------------
  int _ENET_CALLING_CONVENTION_ GetEnetInstance(IEnet** ppInt)
	{
		CEnet* pEnet=new CEnet();
		*ppInt=(IEnet*)pEnet;
		return 1;
	}

